package gomod

import (
	"fmt"
	"net/http"
	"path/filepath"
	"encoding/json"
	"payease_declaration/models"
	"payease_declaration/utils"
)

//二级商户入网信息提交
func SubMerchantDeclareRequest(w http.ResponseWriter, r *http.Request) {
	//接口地址
	apiurl := "https://apis.5upay.com/declaration/submerchant/subMerchantDeclare"
	//pfx私钥
	privatepfxpath, pfxerr := filepath.Abs("src/payease_declaration/package/client.pfx")
	if pfxerr != nil {  
	   fmt.Println("pfxerr:", pfxerr)  
	} 
	pfxpwd := "123456"
    //cer公钥
	publiccerpath, cererr := filepath.Abs("src/payease_declaration/package/payease.cer")
	if cererr != nil {  
	   fmt.Println("cererr:", cererr)  
	} 
    var aesKeyValue string  = utils.GetRandomString(16)
	r.ParseForm()
	var sm models.SubMerchant
	sm.MerchantId = utils.IsNull(r.Form["merchantId"])
    sm.RequestId = utils.IsNull(r.Form["requestId"])
    sm.OperationType = utils.IsNull(r.Form["operationType"])
    sm.SubMerchantId = utils.IsNull(r.Form["subMerchantId"])
    sm.SignedName = utils.IsNull(r.Form["signedName"])
    sm.Email = utils.IsNull(r.Form["email"])
    sm.Phone = utils.IsNull(r.Form["phone"])
    sm.BusinessScope = utils.IsNull(r.Form["businessScope"])
    sm.AuthUserId = utils.IsNull(r.Form["authUserId"])
    sm.AuthEnterpriseId = utils.IsNull(r.Form["authEnterpriseId"])
    sm.HasAgreeProtocol = utils.IsNull(r.Form["hasAgreeProtocol"])
	
	var dsmc models.DeclarationSubMerchantCertificate
	dsmc.RegisterRole = utils.IsNull(r.Form["registerRole"])
    dsmc.BusinessLicensePath = utils.IsNull(r.Form["businessLicensePath"])
    dsmc.OpenAccountPath = utils.IsNull(r.Form["openAccountPath"])
    dsmc.LegalIdCardProsPath = utils.IsNull(r.Form["legalIdCardProsPath"])
    dsmc.LegalIdCardConsPath = utils.IsNull(r.Form["legalIdCardConsPath"])
    dsmc.SettleBankCardPath = utils.IsNull(r.Form["settleBankCardPath"])
    dsmc.OtherCerPath = utils.IsNull(r.Form["otherCerPath"])
    dsmc.Name = utils.IsNull(r.Form["name"])
    dsmc.IdType = utils.IsNull(r.Form["idType"])
    dsmc.IdNo = utils.IsNull(r.Form["idNo"])
    dsmc.EffectiveDateStart = utils.IsNull(r.Form["effectiveDateStart"])
    dsmc.EffectiveDateEnd = utils.IsNull(r.Form["effectiveDateEnd"])
	sm.DeclarationSubMerchantCertificate=dsmc
	 
	dsmrd1 := models.DeclarationSubMerchantRiskDocs{
		DocCode:  "REGISTER_AMOUNT",
		Answer: utils.IsNull(r.Form["REGISTER_AMOUNT"]),
	}
 
	dsmrd2 := models.DeclarationSubMerchantRiskDocs{
		DocCode:  "STAFF_SIZE",
		Answer: utils.IsNull(r.Form["STAFF_SIZE"]),
	}
	dsmrd3 := models.DeclarationSubMerchantRiskDocs{
		DocCode:  "OFFICE_SPACE",
		Answer: utils.IsNull(r.Form["OFFICE_SPACE"]),
	}
	var dsmrd []models.DeclarationSubMerchantRiskDocs
	dsmrd=append(dsmrd,dsmrd1)
	dsmrd=append(dsmrd,dsmrd2)
	dsmrd=append(dsmrd,dsmrd3)
	 
	sm.DeclarationSubMerchantRiskDocs=dsmrd
	 
	fmt.Println("sm:",sm) 
	//把提交对象数据转JSON字符串
	smdata, err := json.Marshal(sm)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}  
	sortdata, oerr := utils.GetMapSortJson(string(smdata))
	if oerr != nil {
        fmt.Println("oerr:", oerr)
    } 
	hm := utils.Sha1(sortdata)
	hmac,err := utils.Sign(hm,privatepfxpath,pfxpwd)
	if err != nil {
        fmt.Println("err:", err)
    } 
	sm.Hmac = hmac
	orderjson, err := json.Marshal(sm)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}
	encryptKey,enerr := utils.PublicEncrypt(aesKeyValue, publiccerpath)
	if enerr != nil {
        fmt.Println("err:", enerr)
    } 
	aesdata,aeserro := utils.AesECBEncrypt(string(orderjson), aesKeyValue)
	//fmt.Println("aesdata:", aesdata)
	if aeserro != nil {
        fmt.Println("err:", aeserro)
    } 
	response, rperr := utils.Post(apiurl,encryptKey,sm.MerchantId,sm.RequestId,aesdata,privatepfxpath,pfxpwd)
	if rperr != nil {
        fmt.Println("rperr:", rperr)
    } 
	var smback models.SubMerchantBack
    json.Unmarshal([]byte(response), &smback)
    rhmac := smback.Hmac
    //fmt.Println("rhmac:", rhmac)
    if 	rhmac != ""{
    	sortdeldata, oerr := utils.GetDelJson(string(response),"hmac")
		if oerr != nil {
	        fmt.Println("oerr:", oerr)
	    } 
		signhm := utils.Sha1(sortdeldata)
    	verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
    	if verr == nil {
    		status := smback.Status
    		if status == "SUCCESS"{
    			fmt.Println("提交成功:", status)
    			fmt.Fprintf(w, "提交成功:"+status)
    			fmt.Fprintf(w, "\n"+response)
    		}else{
    			fmt.Println("失败:", status)
    			fmt.Fprintf(w, "提交失败异常:"+status)
    			fmt.Fprintf(w, "\n"+response)
    		}
    	}else{
	    	fmt.Println("verr:", verr)
	    	fmt.Fprintf(w, "验签异常")
	    	fmt.Fprintf(w, "\n"+response)
    	}
    }else{
    	fmt.Println("response:", response)
    	fmt.Fprintf(w, response)
    }
}
//二级商户查询
func SubMerchantQueryRequest(w http.ResponseWriter, r *http.Request) {
	//接口地址
	 apiurl := "https://apis.5upay.com/declaration/submerchant/subMerchantQuery"
	 //pfx私钥
	 privatepfxpath, pfxerr := filepath.Abs("src/payease_declaration/package/client.pfx")
	 if pfxerr != nil {  
	    fmt.Println("pfxerr:", pfxerr)  
	 } 
	 pfxpwd := "123456"
     //cer公钥
	 publiccerpath, cererr := filepath.Abs("src/payease_declaration/package/payease.cer")
	 if cererr != nil {  
	    fmt.Println("cererr:", cererr)  
	 } 
     var aesKeyValue string  = utils.GetRandomString(16)
	 r.ParseForm()
	 var querysm models.QuerySubMerchant
	 querysm.MerchantId = utils.IsNull(r.Form["merchantId"])
	 querysm.SubMerchantId = utils.IsNull(r.Form["subMerchantId"])
	  //把订单对象数据转JSON字符串
	 smdata, err := json.Marshal(querysm)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}  
	sortdata, oerr := utils.GetMapSortJson(string(smdata))
	if oerr != nil {
        fmt.Println("oerr:", oerr)
    } 
	hm := utils.Sha1(sortdata)
	hmac,err := utils.Sign(hm,privatepfxpath,pfxpwd)
	if err != nil {
        fmt.Println("err:", err)
    } 
	querysm.Hmac = hmac
	orderjson, err := json.Marshal(querysm)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}
	encryptKey,enerr := utils.PublicEncrypt(aesKeyValue, publiccerpath)
	if enerr != nil {
        fmt.Println("err:", enerr)
    } 
	aesdata,aeserro := utils.AesECBEncrypt(string(orderjson), aesKeyValue)
	//fmt.Println("aesdata:", aesdata)
	if aeserro != nil {
        fmt.Println("err:", aeserro)
    } 
	response, rperr := utils.Post(apiurl,encryptKey,querysm.MerchantId,"",aesdata,privatepfxpath,pfxpwd)
	if rperr != nil {
        fmt.Println("rperr:", rperr)
    } 
	var querysmback models.QuerySubMerchantBack
    json.Unmarshal([]byte(response), &querysmback)
    rhmac := querysmback.Hmac
    //fmt.Println("querysm:", querysmback)
    if 	rhmac != ""{
    	sortdeldata, oerr := utils.GetDelJson(string(response),"hmac")
		if oerr != nil {
	        fmt.Println("oerr:", oerr)
	    } 
		signhm := utils.Sha1(sortdeldata)
    	verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
    	if verr == nil {
    		status := querysmback.Status
    		if status == "SUCCESS"{
				fmt.Println("SUCCESS")
				fmt.Println("响应成功!")
				fmt.Println("response:", response)
				fmt.Fprintf(w, "响应成功:"+status)
    			fmt.Fprintf(w, "\n"+response)			
			}else{
				fmt.Println("响应异常:", status)
				fmt.Println("response:", response)
				fmt.Fprintf(w, "响应异常:"+status)
    			fmt.Fprintf(w, "\n"+response)
			}
    	}else{
	    	fmt.Println("verr:", verr)
    	}
    }else{
    	fmt.Println("response:", response)
    	fmt.Fprintf(w, "response:"+response)
    }
}