package models

//二级商户结算配置信息
type SettlementProfile  struct{
	MerchantId string `json:"merchantId"` //商户号
    RequestId string `json:"requestId"`   //订单号
    SubMerchantId string `json:"subMerchantId"`//二级商户编号
    SettleMode  string `json:"settleMode"`    //结算模式
    CycleType string `json:"cycleType"`       //周期类型
    CycleData  string `json:"cycleData"`      //结算日期
    MinAmount string `json:"minAmount"` //起结金额
    RecName string `json:"recName"`   //收款方帐户名称
	RecBankAccountNo string `json:"recBankAccountNo"` //收款方帐户号
	RecIdCardNum string `json:"recIdCardNum"`   	  //收款人身份证号
	RecBankPhoneNum string `json:"recBankPhoneNum"`   //收款预留手机号
	RecBankCode string `json:"recBankCode"`   		//收款帐户银行编码
	RecBranchBankName string `json:"recBranchBankName"`//开户行支付名称
	RecProvinceCode string `json:"recProvinceCode"`   //收款方省编码
	RecCityCode string `json:"recCityCode"`   //收款方市编码
	RecAccountType string `json:"recAccountType"`   //收款人账户类型
    Hmac string `json:"hmac"`             //参数签名
}
//二级商户结算配置响应
type SettlementProfileBack struct{
	MerchantId string `json:"merchantId"` //商户号
    RequestId string `json:"requestId"`   //订单号
    SubMerchantId string `json:"subMerchantId"`//二级商户编号
    SerialNumber string `json:"serialNumber"`   //订单流水号
    ResponseObject
}
//二级商户计费信息配置提交
type Billing struct{
	MerchantId string `json:"merchantId"` //商户号
    RequestId string `json:"requestId"`   //订单号
    SubMerchantId string `json:"subMerchantId"`//二级商户编号
    BillingRule
    Hmac string `json:"hmac"`             //参数签名
}

//二级商户计费信息配置提交响应
type BillingBack struct{
	MerchantId string `json:"merchantId"` //商户号
    RequestId string `json:"requestId"`   //订单号
    SubMerchantId string `json:"subMerchantId"`//二级商户编号
    SerialNumber string `json:"serialNumber"`   //订单流水号
    ResponseObject
}
//二级商户结算配置查询
type BillingRuleQuery  struct{
	MerchantId string `json:"merchantId"` //商户号
    SubMerchantId string `json:"subMerchantId"`//二级商户编号
    Hmac string `json:"hmac"`             //参数签名
}
//二级商户结算配置查询响应
type BillingRuleQueryBack  struct{
	MerchantId string `json:"merchantId"` //商户号
    SubMerchantId string `json:"subMerchantId"`//二级商户编号
    SettleMode  string `json:"settleMode"`    //结算模式
    CycleType string `json:"cycleType"`       //周期类型
    CycleData  string `json:"cycleData"`      //结算日期
    MinAmount string `json:"minAmount"` //起结金额
    RecName string `json:"recName"`   //收款方帐户名称
	RecBankAccountNo string `json:"recBankAccountNo"` //收款方帐户号
	RecIdCardNum string `json:"recIdCardNum"`   	  //收款人身份证号
	RecBankCode string `json:"recBankCode"`   		//收款帐户银行编码
	RecBranchBankName string `json:"recBranchBankName"`//开户行支付名称
	RecProvinceCode string `json:"recProvinceCode"`   //收款方省编码
	RecCityCode string `json:"recCityCode"`   //收款方市编码
	RecAccountType string `json:"recAccountType"`   //收款人账户类型
	BillingRule BillingRule `json:"billingRule"`   //计费信息
    ResponseObject
}
//计费信息
type BillingRule  struct{
	BillingMode string `json:"billingMode"`    //计费模式
    FeeType string `json:"feeType"`     //收费类型
    FeeValue string `json:"feeValue"`   //收费值
    MinFeeAmount string `json:"minFeeAmount"` //最小收费金额
    MaxFeeAmount string `json:"maxFeeAmount"`  //最大收费金额
}