	package models

// 提交二级商户入网信息
type SubMerchant struct {
	MerchantId string `json:"merchantId"`
    RequestId string `json:"requestId"`
    OperationType string `json:"operationType"`
    SubMerchantId string `json:"subMerchantId"`
    SignedName string `json:"signedName"`
    Email string `json:"email"`
    Phone string `json:"phone"`
    BusinessScope string `json:"businessScope"`
    AuthUserId string `json:"authUserId"`
    AuthEnterpriseId string `json:"authEnterpriseId"`
    HasAgreeProtocol string `json:"hasAgreeProtocol"`
    DeclarationSubMerchantCertificate DeclarationSubMerchantCertificate `json:"declarationSubMerchantCertificate"`
    DeclarationSubMerchantRiskDocs []DeclarationSubMerchantRiskDocs `json:"declarationSubMerchantRiskDocs"`
    Hmac string `json:"hmac"`
}

//二级商户资质信息
type DeclarationSubMerchantCertificate struct {
    RegisterRole  string  `json:"registerRole"`
    BusinessLicensePath  string `json:"businessLicensePath"`
    OpenAccountPath  string `json:"openAccountPath"`
    LegalIdCardProsPath string `json:"legalIdCardProsPath"`
    LegalIdCardConsPath string `json:"legalIdCardConsPath"`
    SettleBankCardPath  string  `json:"settleBankCardPath"`
    OtherCerPath  string `json:"otherCerPath"`
    Name  string `json:"name"`
    IdType string `json:"idType"`
    IdNo string `json:"idNo"`
    EffectiveDateStart string `json:"effectiveDateStart"`
    EffectiveDateEnd string `json:"effectiveDateEnd"`
}

// 二级商户信息风险评级题目信息
type DeclarationSubMerchantRiskDocs struct {
    DocCode  string  `json:"docCode"`
    Answer  string `json:"answer"`
}

//提交二级商户入网请求后响应数据
type SubMerchantBack struct{
	MerchantId string `json:"merchantId"`    
    RequestId string `json:"requestId"`
    SubMerchantId string `json:"subMerchantId"`
    ResponseObject
}

// 提交查询二级商户入网信息
type QuerySubMerchant struct {
	MerchantId string `json:"merchantId"`
    SubMerchantId string `json:"subMerchantId"`
    Hmac string `json:"hmac"`
}

//查询二级商户信息响应内容
type QuerySubMerchantBack struct{
	MerchantId string `json:"merchantId"`    
    SubMerchantId string `json:"subMerchantId"`
    SubMerchantReviewStatus string `json:"subMerchantReviewStatus"`    
    SubMerchantReviewRemark string `json:"subMerchantReviewRemark"`
    ResponseObject
}